diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecord.java b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecord.java
index 8f28887..7883c8f 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecord.java
@@ -56,6 +56,10 @@ public class KeyRecord implements IDBObj, IKeyRecord {
     private Date mCreateTime = null;
     private Date mModifyTime = null;
     private String mArchivedBy = null;
+    private String mClientId = null;
+    private String mStatus = null;
+    private String mDataType = null;
+    
 
     protected static Vector<String> mNames = new Vector<String>();
     static {
@@ -71,6 +75,9 @@ public class KeyRecord implements IDBObj, IKeyRecord {
         mNames.addElement(ATTR_CREATE_TIME);
         mNames.addElement(ATTR_MODIFY_TIME);
         mNames.addElement(ATTR_ARCHIVED_BY);
+        mNames.addElement(ATTR_CLIENT_ID);
+        mNames.addElement(ATTR_STATUS);
+        mNames.addElement(ATTR_DATA_TYPE);
     }
 
     /**
@@ -128,6 +135,12 @@ public class KeyRecord implements IDBObj, IKeyRecord {
             mModifyTime = (Date) object;
         } else if (name.equalsIgnoreCase(ATTR_ARCHIVED_BY)) {
             mArchivedBy = (String) object;
+        } else if (name.equalsIgnoreCase(ATTR_CLIENT_ID)) {
+            mClientId = (String) object;
+        } else if (name.equalsIgnoreCase(ATTR_DATA_TYPE)) {
+            mDataType = (String) object;
+        } else if (name.equalsIgnoreCase(ATTR_STATUS)) {
+            mStatus = (String) object;
         } else {
             throw new EBaseException(com.netscape.certsrv.apps.CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
         }
@@ -162,6 +175,12 @@ public class KeyRecord implements IDBObj, IKeyRecord {
             return mMetaInfo;
         } else if (name.equalsIgnoreCase(ATTR_ARCHIVED_BY)) {
             return mArchivedBy;
+        } else if (name.equalsIgnoreCase(ATTR_CLIENT_ID)) {
+            return mClientId;
+        } else if (name.equalsIgnoreCase(ATTR_DATA_TYPE)) {
+            return mDataType;
+        } else if (name.equalsIgnoreCase(ATTR_STATUS)) {
+            return mStatus;
         } else {
             throw new EBaseException(com.netscape.certsrv.apps.CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
         }
@@ -342,4 +361,11 @@ public class KeyRecord implements IDBObj, IKeyRecord {
     public Date getModifyTime() {
         return mModifyTime;
     }
+
+    /**
+     * Retrieves the client ID of this record.
+     */
+    public String getClientId() throws EBaseException {
+        return mClientId ;
+    }
 }
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java
index 269a94c..b1c7eca 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java
@@ -129,6 +129,19 @@ public class KeyRepository extends Repository implements IKeyRepository {
             reg.registerAttribute(KeyRecord.ATTR_ARCHIVED_BY, new
                     StringMapper(KeyDBSchema.LDAP_ATTR_ARCHIVED_BY));
         }
+        if (!reg.isAttributeRegistered(KeyRecord.ATTR_CLIENT_ID)) {
+            reg.registerAttribute(KeyRecord.ATTR_CLIENT_ID, new
+                    StringMapper(KeyDBSchema.LDAP_ATTR_CLIENT_ID));
+        }
+        if (!reg.isAttributeRegistered(KeyRecord.ATTR_STATUS)) {
+            reg.registerAttribute(KeyRecord.ATTR_STATUS, new
+                    StringMapper(KeyDBSchema.LDAP_ATTR_STATUS));
+        }
+        if (!reg.isAttributeRegistered(KeyRecord.ATTR_DATA_TYPE)) {
+            reg.registerAttribute(KeyRecord.ATTR_DATA_TYPE, new
+                    StringMapper(KeyDBSchema.LDAP_ATTR_DATA_TYPE));
+        }
+
     }
 
     public void setKeyStatusUpdateInterval(IRepository requestRepo, int interval) {
@@ -230,7 +243,7 @@ public class KeyRepository extends Repository implements IKeyRepository {
     }
 
     /**
-     * Recovers an archived key by owner name.
+     * Recovers an archived key by owner name.readKeyRecord
      * <P>
      * 
      * @param ownerName owner name
diff --git a/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMRestClient.java b/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMRestClient.java
index 06d5d96..b3cdc15 100644
--- a/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMRestClient.java
+++ b/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMRestClient.java
@@ -49,12 +49,13 @@ public class DRMRestClient {
         return list;
     }
     
-    public KeyRequestInfo archiveSecurityData(byte[] encoded, String clientId) {
+    public KeyRequestInfo archiveSecurityData(byte[] encoded, String clientId, String dataType) {
         // create archival request
         ArchivalRequestData data = new ArchivalRequestData();
         String req1 = com.netscape.osutil.OSUtil.BtoA(encoded);
         data.setWrappedPrivateData(req1);
         data.setClientId(clientId);
+        data.setDataType(dataType);
 
         KeyRequestInfo info = keyRequestClient.archiveKey(data);
         return info;
@@ -75,7 +76,7 @@ public class DRMRestClient {
         return null;
     }
     
-    public KeyRequestInfo requestRecovery(String keyId, byte[] rpwd, byte[] rkey) {
+    public KeyRequestInfo requestRecovery(String keyId, byte[] rpwd, byte[] rkey, byte[] nonceData) {
         // create recovery request
         RecoveryRequestData data = new RecoveryRequestData();
         data.setKeyId(keyId);
@@ -85,6 +86,10 @@ public class DRMRestClient {
         if (rkey != null) {
             data.setTransWrappedSessionKey(com.netscape.osutil.OSUtil.BtoA(rkey));
         }
+        
+        if (nonceData != null) {
+            data.setNonceData(com.netscape.osutil.OSUtil.BtoA(nonceData));
+        }
 
         KeyRequestInfo info = keyRequestClient.recoverKey(data);
         return info;
@@ -94,7 +99,7 @@ public class DRMRestClient {
         keyRequestClient.approveRequest(recoveryId);
     }
     
-    public KeyData retrieveKey(String keyId, String requestId, byte[] rpwd, byte[] rkey) { 
+    public KeyData retrieveKey(String keyId, String requestId, byte[] rpwd, byte[] rkey, byte[] nonceData) { 
         // create recovery request
         RecoveryRequestData data = new RecoveryRequestData();
         data.setKeyId(keyId);
@@ -105,6 +110,11 @@ public class DRMRestClient {
         if (rpwd != null) {
             data.setSessionWrappedPassphrase(com.netscape.osutil.OSUtil.BtoA(rpwd));
         }
+        
+        if (nonceData != null) {
+            data.setNonceData(com.netscape.osutil.OSUtil.BtoA(nonceData));
+        }
+        
         KeyData key = keyClient.retrieveKey(data);
         return key;
     }
diff --git a/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMTest.java b/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMTest.java
index a8560dc..341561a 100644
--- a/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMTest.java
+++ b/pki/base/kra/functional/src/com/netscape/cms/servlet/test/DRMTest.java
@@ -17,6 +17,7 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.test;
 
+import java.io.ByteArrayInputStream;
 import java.io.ByteArrayOutputStream;
 import java.io.CharConversionException;
 import java.io.IOException;
@@ -27,11 +28,13 @@ import java.security.cert.CertificateEncodingException;
 import java.util.Calendar;
 import java.util.Collection;
 import java.util.Iterator;
+import java.util.Random;
+
 import org.mozilla.jss.CryptoManager;
 import org.mozilla.jss.asn1.BIT_STRING;
+import org.mozilla.jss.asn1.InvalidBERException;
 import org.mozilla.jss.asn1.OBJECT_IDENTIFIER;
 import org.mozilla.jss.asn1.OCTET_STRING;
-import org.mozilla.jss.asn1.SEQUENCE;
 import org.mozilla.jss.crypto.AlreadyInitializedException;
 import org.mozilla.jss.crypto.BadPaddingException;
 import org.mozilla.jss.crypto.Cipher;
@@ -43,13 +46,16 @@ import org.mozilla.jss.crypto.KeyGenAlgorithm;
 import org.mozilla.jss.crypto.KeyGenerator;
 import org.mozilla.jss.crypto.KeyWrapAlgorithm;
 import org.mozilla.jss.crypto.KeyWrapper;
+import org.mozilla.jss.crypto.PBEAlgorithm;
 import org.mozilla.jss.crypto.SymmetricKey;
 import org.mozilla.jss.crypto.TokenException;
 import org.mozilla.jss.crypto.X509Certificate;
+import org.mozilla.jss.pkcs11.PK11SecureRandom;
+import org.mozilla.jss.pkcs12.PasswordConverter;
+import org.mozilla.jss.pkcs7.EncryptedContentInfo;
 import org.mozilla.jss.pkix.crmf.EncryptedKey;
 import org.mozilla.jss.pkix.crmf.EncryptedValue;
 import org.mozilla.jss.pkix.crmf.PKIArchiveOptions;
-import org.mozilla.jss.pkix.primitive.AVA;
 import org.mozilla.jss.pkix.primitive.AlgorithmIdentifier;
 import org.mozilla.jss.util.Password;
 
@@ -63,6 +69,7 @@ import org.apache.commons.cli.PosixParser;
 import com.netscape.cms.servlet.base.CMSResourceService;
 import com.netscape.cms.servlet.key.model.KeyData;
 import com.netscape.cms.servlet.key.model.KeyDataInfo;
+import com.netscape.cms.servlet.request.KeyRequestResource;
 import com.netscape.cms.servlet.request.model.KeyRequestInfo;
 
 @SuppressWarnings("deprecation")
@@ -124,7 +131,15 @@ public class DRMTest {
         // used for crypto operations
         byte iv[] = { 0x1, 0x1, 0x1, 0x1, 0x1, 0x1, 0x1, 0x1 };
         IVParameterSpec IV = null;
-        IV = new IVParameterSpec(iv);
+        IVParameterSpec IV_server = null;
+        
+        try {
+            IV = genIV(8);
+        } catch (Exception e) {
+            log("Can't generate initialization vector use default: " + e.toString());
+            IV = new IVParameterSpec(iv);
+        }
+        
         CryptoManager manager = null;
         CryptoToken token = null;
         KeyGenerator kg1 = null;
@@ -196,7 +211,7 @@ public class DRMTest {
 
         // Test 2: Get list of completed key archival requests
         log("\n\nList of completed archival requests");
-        Collection<KeyRequestInfo> list = client.listRequests("complete", "enrollment");
+        Collection<KeyRequestInfo> list = client.listRequests("complete", "securityDataEnrollment");
         if (list == null) {
             log("No requests found");
         } else {
@@ -209,7 +224,7 @@ public class DRMTest {
 
         // Test 3: Get list of key recovery requests
         log("\n\nList of completed recovery requests");
-        Collection<KeyRequestInfo> list2 = client.listRequests("complete", "recovery");
+        Collection<KeyRequestInfo> list2 = client.listRequests("complete", "securityDataRecovery");
         if (list2 == null) {
             log("No requests found");
         } else {
@@ -226,9 +241,10 @@ public class DRMTest {
         try {
             kg1 = token.getKeyGenerator(KeyGenAlgorithm.DES3);
             vek = kg1.generate();
-            byte[] encoded = createPKIArchiveOptions(manager, token, transportCert, vek, null, kg1);
+            
+            byte[] encoded = createPKIArchiveOptions(manager, token, transportCert, vek, null, kg1, IV);
 
-            KeyRequestInfo info = client.archiveSecurityData(encoded, clientId);
+            KeyRequestInfo info = client.archiveSecurityData(encoded, clientId, KeyRequestResource.SYMMETRIC_KEY_TYPE);
             log("Archival Results:");
             printRequestInfo(info);
             keyId = getId(info.getKeyURL());
@@ -238,6 +254,7 @@ public class DRMTest {
         }
 
         //Test 5: Get keyId for active key with client ID
+        
         log("Getting key ID for symmetric key");
         keyInfo = client.getKeyData(clientId, "active");
         String keyId2 = getId(keyInfo.getKeyURL());
@@ -249,6 +266,8 @@ public class DRMTest {
 
         if (!keyId.equals(keyId2)) {
             log("Error: key ids from search and archival do not match");
+        } else {
+            log("Success: keyids from search and archival match.");
         }
 
         // Test 6: Submit a recovery request for the symmetric key using a session key
@@ -256,7 +275,7 @@ public class DRMTest {
         try {
             recoveryKey = kg1.generate();
             wrappedRecoveryKey = wrapSymmetricKey(manager, token, transportCert, recoveryKey);
-            KeyRequestInfo info = client.requestRecovery(keyId, null, wrappedRecoveryKey);
+            KeyRequestInfo info = client.requestRecovery(keyId, null, wrappedRecoveryKey, IV.getIV());
             recoveryRequestId = getId(info.getRequestURL());
         } catch (Exception e) {
             log("Exception in recovering symmetric key using session key: " + e.getMessage());
@@ -269,10 +288,12 @@ public class DRMTest {
         // Test 8: Get key
         log("Getting key: " + keyId);
 
-        keyData = client.retrieveKey(keyId, recoveryRequestId, null, wrappedRecoveryKey);
+        keyData = client.retrieveKey(keyId, recoveryRequestId, null, wrappedRecoveryKey, IV.getIV());
         wrappedRecoveredKey = keyData.getWrappedPrivateData();
+        
+        IV_server = new IVParameterSpec( com.netscape.osutil.OSUtil.AtoB(keyData.getNonceData()));
         try {
-            recoveredKey = unwrap(token, IV, wrappedRecoveredKey.getBytes("ISO-8859-1"), recoveryKey);
+            recoveredKey = unwrap(token, IV_server,com.netscape.osutil.OSUtil.AtoB(wrappedRecoveredKey), recoveryKey);
         } catch (Exception e) {
             log("Exception in unwrapping key: " + e.toString());
             e.printStackTrace();
@@ -280,6 +301,8 @@ public class DRMTest {
 
         if (!recoveredKey.equals(com.netscape.osutil.OSUtil.BtoA(vek.getEncoded()))) {
             log("Error: recovered and archived keys do not match!");
+        } else {
+            log("Success: recoverd and archived keys match!");
         }
 
         // Test 9: Submit a recovery request for the symmetric key using a passphrase
@@ -290,7 +313,8 @@ public class DRMTest {
             recoveryKey = kg1.generate();
             wrappedRecoveryPassphrase = wrapPassphrase(token, recoveryPassphrase, IV, recoveryKey);
             wrappedRecoveryKey = wrapSymmetricKey(manager, token, transportCert, recoveryKey);
-            requestInfo = client.requestRecovery(keyId, wrappedRecoveryPassphrase, wrappedRecoveryKey);
+            
+            requestInfo = client.requestRecovery(keyId, wrappedRecoveryPassphrase, wrappedRecoveryKey, IV.getIV());
             recoveryRequestId = getId(requestInfo.getRequestURL());
         } catch (Exception e) {
             log("Exception in recovering symmetric key using passphrase" + e.toString());
@@ -303,19 +327,25 @@ public class DRMTest {
 
         // Test 11: Get key
         log("Getting key: " + keyId);
-        keyData = client.retrieveKey(keyId, recoveryRequestId, wrappedRecoveryPassphrase, wrappedRecoveryKey);
+        keyData = client.retrieveKey(keyId, recoveryRequestId, wrappedRecoveryPassphrase, wrappedRecoveryKey, IV.getIV());
         wrappedRecoveredKey = keyData.getWrappedPrivateData();
+        
         recoveredKey = unwrap(wrappedRecoveredKey, recoveryPassphrase);
 
-        if (!recoveredKey.equals(com.netscape.osutil.OSUtil.BtoA(vek.getEncoded()))) {
+        
+        if (recoveredKey == null || !recoveredKey.equals(com.netscape.osutil.OSUtil.BtoA(vek.getEncoded()))) {
             log("Error: recovered and archived keys do not match!");
+        } else {
+            log("Success: recovered and archived keys do match!");
         }
+        
 
+        passphrase = "secret12345";
         // Test 12: Generate and archive a passphrase
         clientId = "UUID: 123-45-6789 RKEK " + Calendar.getInstance().getTime().toString();
         try {
-            byte[] encoded = createPKIArchiveOptions(manager, token, transportCert, null, passphrase, kg1);
-            requestInfo = client.archiveSecurityData(encoded, clientId);
+            byte[] encoded = createPKIArchiveOptions(manager, token, transportCert, null, passphrase, kg1, IV);
+            requestInfo = client.archiveSecurityData(encoded, clientId, KeyRequestResource.PASS_PHRASE_TYPE);
             log("Archival Results:");
             printRequestInfo(requestInfo);
             keyId = getId(requestInfo.getKeyURL());
@@ -336,6 +366,8 @@ public class DRMTest {
 
         if (!keyId.equals(keyId2)) {
             log("Error: key ids from search and archival do not match");
+        } else {
+            log("Success: key ids from search and archival do match!");
         }
 
         // Test 14: Submit a recovery request for the passphrase using a session key
@@ -346,7 +378,8 @@ public class DRMTest {
         try {
             recoveryKey = kg1.generate();
             wrappedRecoveryKey = wrapSymmetricKey(manager, token, transportCert, recoveryKey);
-            requestInfo = client.requestRecovery(keyId, null, wrappedRecoveryKey);
+            wrappedRecoveryPassphrase = wrapPassphrase(token, recoveryPassphrase, IV, recoveryKey);
+            requestInfo = client.requestRecovery(keyId, null, wrappedRecoveryKey, IV.getIV());
             recoveryRequestId = getId(requestInfo.getRequestURL());
         } catch (Exception e) {
             log("Exception in recovering passphrase using session key: " + e.getMessage());
@@ -359,22 +392,26 @@ public class DRMTest {
         // Test 16: Get key
         log("Getting passphrase: " + keyId);
 
-        keyData = client.retrieveKey(keyId, recoveryRequestId, null, wrappedRecoveryKey);
+        keyData = client.retrieveKey(keyId, recoveryRequestId, null, wrappedRecoveryKey, IV.getIV());
         wrappedRecoveredKey = keyData.getWrappedPrivateData();
+        IV_server = new IVParameterSpec( com.netscape.osutil.OSUtil.AtoB(keyData.getNonceData()));
         try {
-            recoveredKey = unwrap(token, IV, wrappedRecoveredKey.getBytes("ISO-8859-1"), recoveryKey);
+            recoveredKey = unwrap(token, IV_server, com.netscape.osutil.OSUtil.AtoB(wrappedRecoveredKey), recoveryKey);
+            recoveredKey = new String(com.netscape.osutil.OSUtil.AtoB(recoveredKey), "UTF-8");
         } catch (Exception e) {
             log("Exception in unwrapping key: " + e.toString());
             e.printStackTrace();
         }
-
-        if (!recoveredKey.equals(passphrase)) {
+        
+        if (recoveredKey == null || !recoveredKey.equals(passphrase)) {
             log("Error: recovered and archived passphrases do not match!");
+        } else {
+            log("Success: recovered and archived passphrases do match!");
         }
 
         // Test 17: Submit a recovery request for the passphrase using a passphrase
         log("Submitting a recovery request for the passphrase using a passphrase");
-        requestInfo = client.requestRecovery(keyId, wrappedRecoveryPassphrase, wrappedRecoveryKey);
+        requestInfo = client.requestRecovery(keyId, wrappedRecoveryPassphrase, wrappedRecoveryKey, IV.getIV());
         recoveryRequestId = getId(requestInfo.getRequestURL());
 
         //Test 18: Approve recovery
@@ -383,19 +420,80 @@ public class DRMTest {
 
         // Test 19: Get key
         log("Getting passphrase: " + keyId);
-        keyData = client.retrieveKey(keyId, recoveryRequestId, wrappedRecoveryPassphrase, wrappedRecoveryKey);
+        keyData = client.retrieveKey(keyId, recoveryRequestId, wrappedRecoveryPassphrase, wrappedRecoveryKey, IV.getIV());
         wrappedRecoveredKey = keyData.getWrappedPrivateData();
         recoveredKey = unwrap(wrappedRecoveredKey, recoveryPassphrase);
+        try {
+            recoveredKey = new String(com.netscape.osutil.OSUtil.AtoB(recoveredKey), "UTF-8");
+        } catch (Exception e) {
+            log("Error: Can't convert recovered passphrase from binary to ascii!");
+        }
 
-        if (!recoveredKey.equals(passphrase)) {
+        if (recoveredKey == null || !recoveredKey.equals(passphrase)) {
             log("Error: recovered and archived passphrases do not match!");
+        } else {
+            log("Success: recovered and archived passphrases do match!");
+        }
+        
+        // Test 20: Submit a recovery request for the passphrase using a passphrase
+        //Wait until retrieving key before sending input data.
+        
+        log("Submitting a recovery request for the passphrase using a passphrase, wait till end to provide recovery data.");
+        requestInfo = client.requestRecovery(keyId, null, null, null);
+        recoveryRequestId = getId(requestInfo.getRequestURL());
+
+        //Test 21: Approve recovery
+        log("Approving recovery request: " + recoveryRequestId);
+        client.approveRecovery(recoveryRequestId);
+
+        // Test 22: Get key
+        log("Getting passphrase: " + keyId);
+        keyData = client.retrieveKey(keyId, recoveryRequestId, wrappedRecoveryPassphrase, wrappedRecoveryKey, IV.getIV());
+        wrappedRecoveredKey = keyData.getWrappedPrivateData();
+        recoveredKey = unwrap(wrappedRecoveredKey, recoveryPassphrase);
+        try {
+            recoveredKey = new String(com.netscape.osutil.OSUtil.AtoB(recoveredKey), "UTF-8");
+        } catch (Exception e) {
+            log("Error: Can't convert recovered passphrase from binary to ascii!");
         }
 
+        if (recoveredKey == null || !recoveredKey.equals(passphrase)) {
+            log("Error: recovered and archived passphrases do not match!");
+        } else {
+            log("Success: recovered and archived passphrases do match!");
+        }
     }
 
     private static String unwrap(String wrappedRecoveredKey, String recoveryPassphrase) {
-        // TODO Auto-generated method stub
-        return null;
+
+        EncryptedContentInfo cInfo = null;
+        String unwrappedData = null;
+        
+        //We have to do this to get the decoding to work.
+        PBEAlgorithm pbeAlg = PBEAlgorithm.PBE_SHA1_DES3_CBC;
+        
+        log("pbeAlg: " + pbeAlg);
+        try {
+            Password pass = new Password(recoveryPassphrase.toCharArray());
+            PasswordConverter passConverter = new
+                    PasswordConverter();
+
+            byte[] encoded = com.netscape.osutil.OSUtil.AtoB(wrappedRecoveredKey);
+
+            ByteArrayInputStream inStream = new ByteArrayInputStream(encoded);
+            cInfo = (EncryptedContentInfo)
+                      new EncryptedContentInfo.Template().decode(inStream);
+
+            byte[] decodedData = cInfo.decrypt(pass, passConverter);
+
+            unwrappedData = com.netscape.osutil.OSUtil.BtoA(decodedData);
+
+        } catch (Exception e) {
+            log("Problem unwraping PBE wrapped datat! " + e.toString());
+
+        }
+
+        return unwrappedData;
     }
 
     private static void log(String string) {
@@ -407,31 +505,24 @@ public class DRMTest {
             SymmetricKey recoveryKey) throws NoSuchAlgorithmException, TokenException, BadPaddingException,
             IllegalBlockSizeException, InvalidKeyException, InvalidAlgorithmParameterException {
 
-        if (wrappedRecoveredKey == null || recoveryKey == null || token == null) {
-            return null;
-        }
-
         Cipher decryptor = token.getCipherContext(EncryptionAlgorithm.DES3_CBC_PAD);
         decryptor.initDecrypt(recoveryKey, IV);
         byte[] unwrappedData = decryptor.doFinal(wrappedRecoveredKey);
-        String unwrappedS = new String(unwrappedData);
+        String unwrappedS = com.netscape.osutil.OSUtil.BtoA( unwrappedData);
 
         return unwrappedS;
     }
 
     private static String getId(String link) {
-        return link.substring(link.lastIndexOf("/"));
+        return link.substring(link.lastIndexOf("/") + 1);
     }
 
     private static byte[] createPKIArchiveOptions(CryptoManager manager, CryptoToken token, String transportCert,
-            SymmetricKey vek, String passphrase, KeyGenerator kg1) throws TokenException, CharConversionException,
+            SymmetricKey vek, String passphrase, KeyGenerator kg1, IVParameterSpec IV) throws TokenException, CharConversionException,
             NoSuchAlgorithmException, InvalidKeyException, InvalidAlgorithmParameterException,
             CertificateEncodingException, IOException, IllegalStateException, IllegalBlockSizeException,
             BadPaddingException {
         byte[] key_data = null;
-        byte iv[] = { 0x1, 0x1, 0x1, 0x1, 0x1, 0x1, 0x1, 0x1 };
-        IVParameterSpec IV = null;
-        IV = new IVParameterSpec(iv);
 
         //generate session key
         SymmetricKey sk = kg1.generate();
@@ -450,17 +541,35 @@ public class DRMTest {
 
         // create PKIArchiveOptions structure
         AlgorithmIdentifier algS = new AlgorithmIdentifier(new OBJECT_IDENTIFIER("1.2.840.113549.3.7"),
-                new OCTET_STRING(iv));
+                new OCTET_STRING(IV.getIV()));
         EncryptedValue encValue = new EncryptedValue(null, algS, new BIT_STRING(session_data, 0), null, null,
                 new BIT_STRING(key_data, 0));
         EncryptedKey key = new EncryptedKey(encValue);
         PKIArchiveOptions opt = new PKIArchiveOptions(key);
-        SEQUENCE seq = new SEQUENCE();
-        seq.addElement(new AVA(new OBJECT_IDENTIFIER("1.3.6.1.5.5.7.5.1.4"), opt));
-
-        ByteArrayOutputStream bo = new ByteArrayOutputStream();
-        seq.encode(bo);
-        byte[] encoded = bo.toByteArray();
+        
+        byte[] encoded = null;
+        
+        try {
+          
+            //Let's make sure we can decode the encoded PKIArchiveOptions..
+          ByteArrayOutputStream oStream = new ByteArrayOutputStream();
+          
+          opt.encode(oStream);
+          
+          encoded = oStream.toByteArray();
+          ByteArrayInputStream inStream = new ByteArrayInputStream( encoded);
+          PKIArchiveOptions  options = (PKIArchiveOptions)
+                    (new PKIArchiveOptions.Template()).decode(inStream);
+          log("Decoded PKIArchiveOptions: " + options);
+        } catch (IOException e) {
+            log("Problem with PKIArchiveOptions: " + e.toString());
+            return null;
+            
+        } catch (InvalidBERException e) {
+            log("Problem with PKIArchiveOptions: " + e.toString());
+            return null;
+        }
+        
         return encoded;
     }
 
@@ -470,28 +579,16 @@ public class DRMTest {
         byte[] wrappedPassphrase = null;
         Cipher encryptor = null;
 
-        if (passphrase == null || sk == null || token == null || IV == null) {
-            return null;
-        }
-
         encryptor = token.getCipherContext(EncryptionAlgorithm.DES3_CBC_PAD);
         log("cipher " + encryptor);
 
         if (encryptor != null) {
             encryptor.initEncrypt(sk, IV);
-            wrappedPassphrase = encryptor.doFinal(passphrase.getBytes());
-            log("Pass phrase mode key_data: " + wrappedPassphrase);
-
-            // Try to decrypt
-            String wrappedS = new String(wrappedPassphrase, "ISO-8859-1");
-            byte[] pPhrase = wrappedS.getBytes("ISO-8859-1");
-            encryptor.initDecrypt(sk, IV);
-            byte[] decrypted = encryptor.doFinal(pPhrase);
-            String s = new String(decrypted, "ISO-8859-1");
-            log("Re decrypted pass phrase " + s + " decrypted.size " + decrypted.length);
+            wrappedPassphrase = encryptor.doFinal(passphrase.getBytes("UTF-8"));
         } else {
             throw new IOException("Failed to create cipher");
         }
+        
         return wrappedPassphrase;
     }
 
@@ -512,5 +609,15 @@ public class DRMTest {
         log("Status:        " + info.getRequestStatus());
         log("Type:          " + info.getRequestType());
     }
+    
+    //Use this when we actually create random initialization vectors
+    private static IVParameterSpec genIV(int blockSize) throws Exception {
+        // generate an IV
+        byte[] iv = new byte[blockSize];
+
+        Random rnd = new Random();
+        rnd.nextBytes(iv);
 
+        return new IVParameterSpec(iv);
+    }
 }
diff --git a/pki/base/kra/shared/conf/schema.ldif b/pki/base/kra/shared/conf/schema.ldif
index caf71e9..70578e2 100644
--- a/pki/base/kra/shared/conf/schema.ldif
+++ b/pki/base/kra/shared/conf/schema.ldif
@@ -161,6 +161,21 @@ attributeTypes: ( keySize-oid NAME 'keySize' DESC 'CMS defined attribute' SYNTAX
 dn: cn=schema
 changetype: modify
 add: attributeTypes
+attributeTypes: ( clientId-oid NAME 'clientId' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
+
+dn: cn=schema
+changetype: modify
+add: attributeTypes
+attributeTypes: ( dataType-oid NAME 'dataType' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
+
+dn: cn=schema
+changetype: modify
+add: attributeTypes
+attributeTypes: ( status-oid NAME 'status' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
+
+dn: cn=schema
+changetype: modify
+add: attributeTypes
 attributeTypes: ( keyState-oid NAME 'keyState' DESC 'CMS defined attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 X-ORIGIN 'user defined' )
 
 dn: cn=schema
@@ -446,7 +461,7 @@ objectClasses: ( userDetails-oid NAME 'userDetails' DESC 'CMS defined class' SUP
 dn: cn=schema
 changetype: modify
 add: objectClasses
-objectClasses: ( keyRecord-oid NAME 'keyRecord' DESC 'CMS defined class' SUP top STRUCTURAL MUST cn MAY ( serialno $ dateOfCreate $ dateOfModify $ keyState $ privateKeyData $ ownerName $ keySize $ metaInfo $ dateOfArchival $ dateOfRecovery $ algorithm $ publicKeyFormat $ publicKeyData $ archivedBy ) X-ORIGIN 'user defined' )
+objectClasses: ( keyRecord-oid NAME 'keyRecord' DESC 'CMS defined class' SUP top STRUCTURAL MUST cn MAY ( serialno $ dateOfCreate $ dateOfModify $ keyState $ privateKeyData $ ownerName $ keySize $ metaInfo $ dateOfArchival $ dateOfRecovery $ algorithm $ publicKeyFormat $ publicKeyData $ archivedBy $ clientId $ dataType $ status ) X-ORIGIN 'user defined' )
 
 dn: cn=schema
 changetype: modify
